<template>
  <section class="event-card">
    <div class="event-flex">
      <div class="event-poster-container">
        <img class="event-poster" :src="event.image_url" :alt="event.name">
      </div>
      <div class="event-data">
        <h2>{{event.name.toUpperCase()}}</h2>
        <span class="event-description">{{event.description}}</span>
        <br/><br/>
        <span class="event-description">Начало: {{localeStartDatetime}}</span>
      </div>

    </div>
    <EventOptionList class="option-list" :options="event.options" :event_id="event.id" :user_bookings="bookings" :user="user" @input="handleBookingsChange" @checkoutInitiated="handleCheckout"/>
  </section>
</template>

<script>
  import EventOptionList from './EventOptionList'
  import axios from 'axios'
  import moment from 'moment'
  export default {
    name: "EventCard",
    components: { EventOptionList },
    props: ['event', 'user'],
    data() {
      return {
        bookings: []
      }
    },
    created () {
      for (let option of this.event.options) {
        this.bookings.push({
          id: option.id,
          value: 0
        })
      }
    },
    computed: {
      localeStartDatetime() {
        let x = moment(this.event.start).locale("ru-RU");
        return x.format('LLL')
      }
    },
    methods: {
      handleBookingsChange(option_id, value) {
        this.bookings.find((el) => {return el.id === option_id}).value = value;
      },
      handleCheckout() {
        axios.post(`${this.$hostname}/api/event/${this.event.id}/book/`, this.bookings).then((response) => {
          alert('Оплата произведена успешно!');
        }).catch((error) => {
          alert(error);
        })
      }
    }
  }
</script>

<style scoped>
.event-card {
  display: grid;
  grid-template-columns: 40% 1fr;
  grid-template-rows: 1fr auto;
  grid-column-gap: 20px;
}

.event-flex {
  grid-column: 1 / span 2;
  grid-row: 1;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  justify-content: flex-start;
  align-items: stretch;
}

.event-poster-container {
  flex-grow: 0;
  max-width: 35%;
}

.event-poster-container img {
  object-fit: contain;
  max-width: 100%;
  max-height: 100%;

  border-radius: 40px;
  border: 1px solid black;
}

.event-data {
  margin-left: 10px;
  flex-grow: 1;
}

h2 {
  font-size: 36pt;
}

.event-description {
  color: white;
  font-size: 12pt;
}

.option-list {
  margin-left: 60px;
  margin-top: 20px;
  grid-row: 2;
  grid-column: 1 / span 2;
}
</style>
